#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

const int ARRAY_LEN = 35000;

void shuffle (int array[]);
void bruteForce (int array[]);
void print (int array[]);

int main()
{
	int array[ARRAY_LEN] = {0};

	// algorithm 1 ===============================
	// record the starting time
	long int stTime = 0, endTime = 0;
	double duration = 0;	
	stTime = clock();

	// run algorithm 1
	shuffle (array);

	// calculate the duration
	endTime = clock();
	duration = static_cast<double> (endTime - stTime);
	duration = duration / CLK_TCK;
	cout << "seconds for algorithm 1: " << duration << endl; 
	// end of algorithm 1 ===============================
	
	// algorithm 2 ===============================
	// record the starting time
	stTime = clock();

	// run algorithm 2
	bruteForce (array);

	// calculate the duration
	endTime = clock();
	duration = static_cast<double> (endTime - stTime);
	duration = duration / CLK_TCK;
	cout << "seconds for algorithm 2: " << duration << endl; 
	// end of algorithm 2 ===============================

	return 0;
}

void shuffle (int array[])
{
	// initialize the array
	for (int i = 0; i < ARRAY_LEN; i++)
		array[i] = i;
	
	// shuffle the array
	srand(time(0));
	for (int i = 0; i < ARRAY_LEN; i++)
	{
		int chosenIndex = rand() % ARRAY_LEN;
		int temp = array[i];
		array[i] = array[chosenIndex];
		array[chosenIndex] = temp;
	}	
}

void bruteForce (int array[])
{
	// in each iteration, set one value
	for (int i = 0; i < ARRAY_LEN; i++)
	{
		// try to generate a randome number
		int theRand = rand() % ARRAY_LEN;
		
		// check whether this number has been generated
		bool hasRepeated = false;
		for (int j = 0; j < i; j++)
		{
			if (theRand == array[j])
			{
				hasRepeated = true;
				break;
			}
		}
		
		// if not, set it; otherwise, try again
		if (hasRepeated == false)
			array[i] = theRand;
		else
			i--;
	}
}

void print (int array[])
{
	for (int i = 0; i < ARRAY_LEN; i++)
	{
		cout << array[i] << " ";	
		if (i % 10 == 9)
			cout << endl;
	}
}


